<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Insert Use</title>
</head>

<body>
    <div class="container">
        <h1>Thêm User</h1>
        <div class="form-group row">
            <label for="inp-firstname" class="col-sm-2 col-form-label">First Name</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="inp-firstname">
            </div>
        </div>
        <div class="form-group row">
            <label for="inp-lastname" class="col-sm-2 col-form-label">Last Name</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="inp-lastname">
            </div>
        </div>
        <div class="form-group row">
            <label for="inp-subject" class="col-sm-2 col-form-label">Subject</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="inp-subject">
            </div>
        </div>
        <div class="form-group row">
            <label for="select-country" class="col-sm-2 col-form-label">Country</label>
            <div class="col-sm-10">
                <select name="" id="select-country" class="form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="form-group row">
            <label for="select-customer-type" class="col-sm-2 col-form-label">Customer Type</label>
            <div class="col-sm-10">
                <select name="" id="select-customer-type" class="form-control">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>

                </select>
            </div>
        </div>
        <div class="btn-group">
            <button class="btn btn-success mr-1 btn-insert">Insert User</button>
            <button class="btn btn-success btn-cancel">Hủy bỏ</button>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gNewUserObj = {
        firstname: "",
        lastname: "",
        subject: "",
        country: "",
        customerType: ""
    }

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        $(".btn-insert").on("click", function () {
            //b1: truy xuat du lieu
            truyXuatDuLieuTrenForm(gNewUserObj);
            //b2: validate du lieu
            var duLieuHopLe = validateDuLieu(gNewUserObj);
            if (duLieuHopLe) {
                //b3: goi api insert user
                $.ajax({
                    url: "http://203.171.20.210:8080/crud-api/users/",
                    type: "POST",
                    contentType: "application/json",
                    data: JSON.stringify(gNewUserObj),
                    //b4: hien thi thong tin

                    success: function (res) {
                        console.log(res);
                        alert("Thêm mới user thành công!")
                        window.location.href = "listUser.html"
                    },
                    error: function (ajaxContext) {
                        alert(ajaxContext.responseText)
                        window.location.href = "listUser.html"

                    }
                });
            }

        });
        $(".btn-cancel").on("click", function () {
            window.location.href = "listUser.html"
        });
    });

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //b1: truy xuat du lieu
    function truyXuatDuLieuTrenForm(paramUserObj) {
        paramUserObj.firstname = $.trim($("#inp-firstname").val());
        paramUserObj.lastname = $.trim($("#inp-lastname").val());
        paramUserObj.subject = $.trim($("#inp-subject").val());
        paramUserObj.country = $("#select-country").val();
        paramUserObj.customerType = $("#select-customer-type").val();
    };
    //b2: validate du lieu
    function validateDuLieu(paramUserObj) {
        if (paramUserObj.firstname == "") {
            alert("Hãy nhập firstname!");
            return false;
        }
        if (paramUserObj.lastname == "") {
            alert("Hãy nhập lastname!");
            return false;
        }
        if (paramUserObj.subject == "") {
            alert("Hãy nhập subject!");
            return false;
        }
        if (paramUserObj.country == null) {
            alert("Hãy chọn country!");
            return false;
        }
        if (paramUserObj.customerType == null) {
            alert("Hãy chọn customer type!");
            return false;
        }

        return true;
    };



</script>

</html>